import { getInternalCsvMapping } from './getInternalCsvMapping.js';
export const bindParsing = (container, parser, index, mapping) => {
    const schema = getInternalCsvMapping(mapping, parser.delimiter);
    const rowTemplate = schema.collsNames.map(() => undefined);
    let row = [...rowTemplate];
    container.rows[index].push({
        row: [...schema.collsNames],
        end: false
    });
    const lastElValue = new Map();
    const ctx = { lastElValue };
    const collectionValueHandler = (elName, value) => {
        // Process value before row complete logic in case where row tag contain text
        //#region Value
        lastElValue.set(elName, value);
        const mappings = schema.collsMappings[elName];
        let colls = undefined;
        if (mappings !== undefined) {
            colls = mappings.filter(m => (m.predicate?.(ctx, value) ?? true) === true);
        }
        // Field value
        if (colls !== undefined) {
            for (let i = 0, len = colls.length; i < len; i++) {
                const coll = colls[i];
                if (coll === undefined)
                    throw new Error('coll === undefined');
                const _val = value === '' ? coll.defaultValue : value;
                if (coll.isOutOfRowTag) {
                    rowTemplate[coll.index] = _val;
                }
                else {
                    row[coll.index] = _val;
                }
            }
        }
        //#endregion
        // Row completed
        if (schema.row === elName) {
            container.rows[index].push(
            //
            {
                row,
                end: false
            });
            row = [...rowTemplate];
            lastElValue.clear();
        }
        // Table completed
        else if (schema.collection === elName) {
            container.rows[index].push({
                row: null,
                end: true
            });
            console.info(`Completed parsing "${schema.collection}" collection`);
            parser.offValue(collectionValueHandler);
            parser.offElem(rowStartHandler);
        }
    };
    const rowStartHandler = elName => {
        if (schema.row === elName) {
            row = [...rowTemplate];
        }
    };
    parser.onElem(rowStartHandler);
    parser.onValue(collectionValueHandler);
};
//# sourceMappingURL=bindParsing.js.map